/** -*- C -*-
 * Copyright (C) 1999, 2000, 2001  Free Software Foundation, Inc.
 *
 * This file is part of GNU gengetopt 
 *
 * GNU gengetopt is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2, or (at your option) 
 * any later version. 
 *
 * GNU gengetopt is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details. 
 *
 * You should have received a copy of the GNU General Public License along 
 * with gengetopt; see the file COPYING. If not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
 */

%option caseless
%option noyywrap

%{
#include <string.h>
#include "argsdef.h"
#include "parser.h"
extern int gengetopt_count_line;
%}

%%

#:.*               yylval.str = yytext+2; return TOK_LITERAL;
package		   return TOK_PACKAGE;
version		   return TOK_VERSION;
option		   return TOK_OPTION;
string          yylval.argtype = ARG_STRING; return TOK_ARGTYPE;
int		yylval.argtype = ARG_INT; return TOK_ARGTYPE;
short		yylval.argtype = ARG_SHORT; return TOK_ARGTYPE;
long		yylval.argtype = ARG_LONG; return TOK_ARGTYPE;
float		yylval.argtype = ARG_FLOAT; return TOK_ARGTYPE;
double          yylval.argtype = ARG_DOUBLE; return TOK_ARGTYPE;
longdouble      yylval.argtype = ARG_LONGDOUBLE; return TOK_ARGTYPE;
longlong        yylval.argtype = ARG_LONGLONG; return TOK_ARGTYPE;
yes				   return TOK_YES;
no				   return TOK_NO;
flag			   return TOK_FLAG;
on				   yylval.bool = 1; return TOK_ONOFF;
off				   yylval.bool = 0; return TOK_ONOFF;
purpose		   return TOK_PURPOSE;

[[:alnum:]-]			yylval.chr = yytext[0]; return TOK_CHAR;
\"[^\"\n]*\"	{
				/* if you add or remove symbols, change canonize_vars
				   function */
				yytext [strlen(yytext) - 1] = 0;
				yylval.str = yytext + 1;
				return TOK_STRING;
				}
\"[^\"]*\"	{
				/* if you add or remove symbols, change canonize_vars
				   function */
				yytext [strlen(yytext) - 1] = 0;
				yylval.str = yytext + 1;
				return TOK_MLSTRING;
				}

[ \t]+				/* eat spaces */
#.*				/* comments begin with # in any place */
\n				gengetopt_count_line++; return '\n';

.		{ return 1000; /* little hack to produce a parse error too. */ }

%%

